---
title: WebDriver
slug: Web/WebDriver
tags:
  - Automation
  - Index
  - Landing
  - Reference
  - Testing
  - Web
  - WebDriver
---
<p class="summary">WebDriver is a remote control interface that enables introspection and control of user agents. It provides a platform- and language-neutral wire protocol as a way for out-of-process programs to remotely instruct the behavior of web browsers.</p>

<p>To have the ability to write instruction sets that can be run <span>interchangeably in many browsers on different platforms is critical to deliver a consistent experience to users. With the new wave of developments on the web platform, the increase diversity in devices and demands for real interoperability between the technologies, WebDriver provides tooling for <a href="/en-US/Learn/Tools_and_testing/Cross_browser_testing/Introduction">cross-browser testing</a>.</span></p>

<p>Provided is a set of interfaces to discover and manipulate DOM elements in web documents and to control the behavior of a user agent. It is primarily intended to allow web authors to write tests that automate a user agent from a separate controlling process, but may also be used in such a way as to allow in-browser scripts to control a — possibly separate — browser.</p>

<h2 id="Usage">Usage</h2>

<p>So what does WebDriver let you do and what does it look like? Since WebDriver is programming language neutral, the answer to this question <a href="/en-US/docs/Web/WebDriver/Clients">depends on which WebDriver client you’re using</a> and the choice of language.</p>

<p>But using a popular client written in Python, your interaction with WebDriver might look like this:</p>

<pre>from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support.expected_conditions import presence_of_element_located

wait = WebDriverWait(driver, 10)

with webdriver.Firefox() as driver:
    driver.get("http://google.com/ncr")
    driver.find_element_by_name("q").send_keys("cheese" + Keys.RETURN)

    wait.until(presence_of_element_located((By.CSS_SELECTOR, "h3&gt;a")))

    results = driver.find_elements_by_css_selector("h3&gt;a")
    for i, result in results.iteritems():
        print("#{}: {} ({})".format(i, result.text, result.get_property("href")))</pre>

<p>This might produce output akin to this:</p>

<pre>#1 Cheese - Wikipedia (https://en.wikipedia.org/wiki/Cheese)
</pre>

<h2 id="Reference">Reference</h2>

<div class="column-container">
<div class="column-half">
<h3 id="Commands"><a href="/en-US/docs/Web/WebDriver/Commands">Commands</a></h3>

<p>{{ListSubpages("/en-US/docs/Web/WebDriver/Commands")}}</p>

<h3 id="Types"><a href="/en-US/docs/Web/WebDriver/Types">Types</a></h3>

<ul>
 <li><a href="/en-US/docs/Web/WebDriver/Errors#payload">Error object</a></li>
 <li><a href="/en-US/docs/Web/WebDriver/Timeouts">Timeouts object</a></li>
 <li><a href="/en-US/docs/Web/WebDriver/WebElement">WebElement</a></li>
 <li><a href="/en-US/docs/Web/WebDriver/WebWindow">WebWindow</a></li>
</ul>
</div>

<div class="column-half">
<h3 id="Capabilities"><a href="/en-US/docs/Web/WebDriver/Capabilities">Capabilities</a></h3>

<p>{{ListSubpages("/en-US/docs/Web/WebDriver/Capabilities")}}</p>

<h3 id="Errors"><a href="/en-US/docs/Web/WebDriver/Errors">Errors</a></h3>

<p>{{ListSubpages("/en-US/docs/Web/WebDriver/Errors")}}</p>

<ul>
</ul>
</div>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebDriver')}}</td>
   <td>{{Spec2('WebDriver')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("webdriver", 2)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/Tools_and_testing/Cross_browser_testing">Cross browser testing</a></li>
 <li><a href="https://seleniumhq.github.io/docs/">Selenium documentation</a> (work in progress)</li>
</ul>

<p>{{QuickLinksWithSubpages}}</p>
